// SendProgramInLanDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SendProgramInLan.h"
#include "SendProgramInLanDlg.h"
#include "InterFaceDll.h"
#include <Winsock2.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About
int WINAPI ProcessCallBackMessage (int Param1,char * Param2);
HWND m_DlgWnd=NULL;

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSendProgramInLanDlg dialog

CSendProgramInLanDlg::CSendProgramInLanDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSendProgramInLanDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSendProgramInLanDlg)
	m_strProjectPathName = _T("");
	m_strControllerID = _T("");
	m_uiAnycastIndex = 0;
	m_uiBrightNess = 0;
	m_iRadioPower = 0;
	m_strStatus = _T("");
	m_uiWidth = 128;
	m_uiHeight = 32;
	m_strProgramName = _T("demo");
	m_uiVersion = 9;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_CanQuitFlag=0;
	m_strCurLoaclIp="";
}

void CSendProgramInLanDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSendProgramInLanDlg)
	DDX_Control(pDX, IDC_PROGRESS1, m_ctrlProgress);
	DDX_Control(pDX, IDC_IPADDRESS_CARD_IP, m_ctrlIpAddress);
	DDX_Control(pDX, IDC_LIST1, m_ctrlLinkedCardInfo1);
	DDX_Text(pDX, IDC_EDIT_PROJECT_PATHNAME, m_strProjectPathName);
	DDX_Text(pDX, IDC_EDIT_CARD_ID, m_strControllerID);
	DDX_Text(pDX, IDC_EDIT_ANYCAST, m_uiAnycastIndex);
	DDX_Text(pDX, IDC_EDIT_BRIGHTNESS, m_uiBrightNess);
	DDV_MinMaxUInt(pDX, m_uiBrightNess, 0, 7);
	DDX_Radio(pDX, IDC_RADIO_POWER, m_iRadioPower);
	DDX_Text(pDX, IDC_EDIT_STATUS, m_strStatus);
	DDX_Text(pDX, IDC_EDIT_P_WIDTH, m_uiWidth);
	DDX_Text(pDX, IDC_EDIT_P_HEIGHT, m_uiHeight);
	DDX_Text(pDX, IDC_EDIT_PROGRAM_NAME, m_strProgramName);
	DDV_MaxChars(pDX, m_strProgramName, 500);
	DDX_Text(pDX, IDC_EDIT_VERSION, m_uiVersion);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSendProgramInLanDlg, CDialog)
	//{{AFX_MSG_MAP(CSendProgramInLanDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_AUTO_GET_CARD_IN_LAN, OnButtonAutoGetCardInLan)
	ON_BN_CLICKED(IDC_BUTTON_SELECT_PROJECT, OnButtonSelectProject)
	ON_BN_CLICKED(IDC_BUTTON_SEND, OnButtonSend)
	ON_MESSAGE(WM_MSG_DLG_WND,OnMsgPro)
	ON_NOTIFY(NM_CLICK, IDC_LIST1, OnClickList1)
	ON_BN_CLICKED(IDC_BUTTON_GET_STATUS, OnButtonGetStatus)
	ON_BN_CLICKED(IDC_BUTTON_ADJUSIT_BRIGHTNESS, OnButtonAdjusitBrightness)
	ON_BN_CLICKED(IDC_BUTTON_POWER, OnButtonPower)
	ON_BN_CLICKED(IDC_BUTTON_ANYCAST, OnButtonAnycast)
	ON_BN_CLICKED(IDC_BUTTON_DOWNLOAD_FROM_FTP, OnButtonDownloadFromFtp)
	ON_BN_CLICKED(IDC_BUTTON_GET_CUR_PLAYINFO, OnButtonGetCurPlayinfo)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSendProgramInLanDlg message handlers
int WINAPI ProcessCallBackMessage(int Param1/**/,char * Param2/*Ӧ*/)
{
	
	if(	m_DlgWnd==NULL)
		return 0;
	::PostMessage(m_DlgWnd,WM_MSG_DLG_WND,Param1,(LPARAM)Param2);
	
	return 0;
}
//CString GetAppPath()
//{
//	CString m_sCPath,str ;
//	char dir[MAX_PATH] ;
//	HINSTANCE hpin= AfxGetInstanceHandle() ;
//	GetModuleFileName(hpin,dir,MAX_PATH);
//	m_sCPath = dir ;//ǰ·
//	str =  AfxGetApp()->m_pszExeName;
//	str = str+".exe" ;
//	m_sCPath.MakeLower() ;
//	str.MakeLower() ;
//	int ipos ;
//	ipos  =  m_sCPath.Find(str ) ;
//	m_sCPath.Delete(ipos ,str.GetLength()) ;  
//	if ( m_sCPath.Right(1)!='\\')
//	{
//		m_sCPath =  m_sCPath+"\\" ;
//	}
//	return m_sCPath ;
//}
BOOL CSendProgramInLanDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_ctrlLinkedCardInfo1.SetExtendedStyle(LVS_EX_SUBITEMIMAGES| LVS_EX_GRIDLINES|LVS_EX_HEADERDRAGDROP|LVS_EX_FULLROWSELECT);
	CRect rt;
	m_ctrlLinkedCardInfo1.GetClientRect(&rt);
	m_ctrlLinkedCardInfo1.InsertColumn(0, "Card ID", LVCFMT_LEFT, rt.Width()/2);
	m_ctrlLinkedCardInfo1.InsertColumn(1, "IP", LVCFMT_LEFT, rt.Width()/2);
	DLL_Net_Init();
	m_DlgWnd=this->m_hWnd;
	CallBack(ProcessCallBackMessage);
	if (m_hEnableSendNextCmd != NULL)
		ResetEvent(m_hEnableSendNextCmd);
	else
		m_hEnableSendNextCmd = CreateEvent(NULL, TRUE, FALSE, NULL);
	//CString strSaveDir=GetAppPath();
	//m_strProjectPathName =strSaveDir+ _T("test.xml");
	UpdateData(FALSE);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSendProgramInLanDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSendProgramInLanDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSendProgramInLanDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}
int ienableFlag=0;
UINT _Thread_Loop_Card_Ip_In_Net(LPVOID lparam)
{
	if(ienableFlag==1)
		return 0;
	CSendProgramInLanDlg *pDlg=(CSendProgramInLanDlg *)lparam;
	if(pDlg->m_CanQuitFlag==1)
	{	ienableFlag=0;
		return 0;
	}
	ienableFlag=1;
	pDlg->SetCardListByDLL();
	ienableFlag=0;
	return 0;
}
void CSendProgramInLanDlg::OnButtonAutoGetCardInLan() 
{
	// TODO: Add your control notification handler code here
	m_ctrlLinkedCardInfo1.DeleteAllItems();
	::AfxBeginThread(_Thread_Loop_Card_Ip_In_Net,this,THREAD_PRIORITY_BELOW_NORMAL,0,0,NULL);
	
}
void GetCptIpAddress(CStringArray &strArray)
{
	WSADATA WSAData;
	int WSAReturn;
	WSAReturn= WSAStartup(0X0101,&WSAData);
	if(WSAReturn == 0)
	{
		char cHostName[100]={0};
		if(gethostname(cHostName,100))
		{
		}
		struct hostent *p_HostEnt;
		p_HostEnt = gethostbyname(cHostName);
		if(p_HostEnt !=NULL)
		{
			char Hostaddress[20]={0};
			/* Ĺ淶 */
			//printf("official hostname:%s\n",p_HostEnt->h_name);
			//CString strHostName=p_HostEnt->h_name;
			//AfxMessageBox(strHostName);
			//char **pptr=NULL;
			/* жбֱ */
			//p_HostEnt->
			//for(pptr =p_HostEnt->h_aliases; *pptr != NULL; pptr++)
			//{
			//	printf("  alias:%s\n",*pptr);
			//	CString strBieName=*pptr;
			//	AfxMessageBox(strBieName);
			//}
			/* ݵַַͣ */
			switch(p_HostEnt->h_addrtype)
			{
			case AF_INET:
			case AF_INET6:
				{
					//pptr=p_HostEnt->h_addr_list;
					/* ղŵõеַеinet_ntop() */
					strArray.RemoveAll();
					for(int i=0;&p_HostEnt->h_addr_list[i][0]!=NULL;i++)
					{
						wsprintf(Hostaddress,"%d.%d.%d.%d",
							(p_HostEnt->h_addr_list[i][0] & 0x00ff),
							(p_HostEnt->h_addr_list[i][1] & 0x00ff),
							(p_HostEnt->h_addr_list[i][2] & 0x00ff),
							(p_HostEnt->h_addr_list[i][3] & 0x00ff));
						CString strIp="";
						strIp.Format(Hostaddress);
						strArray.Add(strIp);
					}
				}
				break;
			default:
				wsprintf(Hostaddress,"unknown address type\n");
				break;
			}
			
			
			WSACleanup();
		}
		
	}
}
void CSendProgramInLanDlg::SetCardListByDLL()
{
	DLL_Net_ClearCardInLan();
	CStringArray strIpTempArray;
	GetCptIpAddress(strIpTempArray);
	int iCardNumber=strIpTempArray.GetSize();
	for(int inetcard=0;inetcard<iCardNumber;inetcard++)
	{
		m_strCurLoaclIp=strIpTempArray.GetAt(inetcard);
		MACRO_IS_ENABLE_QIUT_FUNC(m_CanQuitFlag,return,ienableFlag)
		char tempLocalIp[20]={0};
		strcpy(tempLocalIp,m_strCurLoaclIp);
		int itemNumber=DLL_Net_GetCardNumberInLan(tempLocalIp);
		
		for(int i=0;i<itemNumber;i++)
		{
			char ip[20]={0};
			char id[20]={0};
			MACRO_IS_ENABLE_QIUT_FUNC(m_CanQuitFlag,return,ienableFlag)
			DLL_Net_GetCardIpFromList(i,ip,id);

			CString strIp=ip;
			CString strId=id;
			MACRO_IS_ENABLE_QIUT_FUNC(m_CanQuitFlag,return,ienableFlag)
			int itempcount=m_ctrlLinkedCardInfo1.GetItemCount();
			int itempHaveFlag=0;
			for(int j=0;j<itempcount;j++)
			{
				MACRO_IS_ENABLE_QIUT_FUNC(m_CanQuitFlag,return,ienableFlag)
				CString strtempIp=m_ctrlLinkedCardInfo1.GetItemText(j,1);
				MACRO_IS_ENABLE_QIUT_FUNC(m_CanQuitFlag,return,ienableFlag)
				CString strtempId=m_ctrlLinkedCardInfo1.GetItemText(j,0);
				if(strcmp(strId,strtempId)==0)
				{
					itempHaveFlag=1;
					if(strcmp(strIp,strtempIp)==0||strcmp(strIp,"")==0)//кͬ
					{
						break;
					}
					else
					{
						m_ctrlLinkedCardInfo1.SetItemText(j, 1,strIp);//кͬiP޸,IP
						break;
					}
				}
				else
				{
					if(strcmp(strIp,strtempIp)==0)//кŲͬ,IPײ
					{

						char *cTip=NULL;
						CString strTip="Detect same ip panels in net,please modify one panel ip.\r\n["+strId+"]\r\n["+strtempId+"]\r\n"+strIp;
						cTip=(char *)malloc(strTip.GetLength()+1);
						memset(cTip,0x00,strTip.GetLength()+1);
						strcpy(cTip,strTip);
						AfxMessageBox(strTip);
					}
				}
			}
			if(itempHaveFlag==0)
			{
				MACRO_IS_ENABLE_QIUT_FUNC(m_CanQuitFlag,return,ienableFlag)
					m_ctrlLinkedCardInfo1.InsertItem(0, "",0);
				MACRO_IS_ENABLE_QIUT_FUNC(m_CanQuitFlag,return,ienableFlag)
					m_ctrlLinkedCardInfo1.SetItemText(0, 0,strId);
				MACRO_IS_ENABLE_QIUT_FUNC(m_CanQuitFlag,return,ienableFlag)
					m_ctrlLinkedCardInfo1.SetItemText(0, 1,strIp);
			}
		}
	}
}

void CSendProgramInLanDlg::OnButtonSelectProject() 
{
	// TODO: Add your control notification handler code here
	CFileDialog dlg(TRUE, NULL, 
		NULL, OFN_HIDEREADONLY, "\r\nPIC FILE(*.xml *.lxd) |*.xml;*.lxd|",
		this);
	dlg.m_ofn.Flags |= OFN_NOCHANGEDIR;	
	if (IDOK == dlg.DoModal())
	{
		m_strProjectPathName=dlg.GetPathName();
		UpdateData(FALSE);
	}	
}
UINT _Thread_Send(LPVOID lparam)
{
	
	CSendProgramInLanDlg *pDlg=(CSendProgramInLanDlg*)lparam;
	pDlg->SendByIP();
	return 0;
}
void CSendProgramInLanDlg::SendByIP() 
{
	UpdateData(TRUE);
	GetDlgItem(IDC_IPADDRESS_CARD_IP)->GetWindowText(m_strIpAddress);
	int m_uiMainVer=m_uiVersion;
	int m_uiChildVer=0x20100915;
	char cIp[20]={0};
	strcpy(cIp,m_strIpAddress);
	char cProgramName[500]={0};
	strcpy(cProgramName,m_strProjectPathName);
	ResetEvent(m_hEnableSendNextCmd);
	if(strcmp(m_strIpAddress,"")==0)
	{
		AfxMessageBox("Ip address can not be empty");
		return;
	}
	GetDlgItem(IDC_BUTTON_SEND)->EnableWindow(FALSE);
	if(DLL_Net_ReadyToSendProgram(cIp,31299,cProgramName,m_uiMainVer,m_uiChildVer,0)==-1)
	{
		GetDlgItem(IDC_BUTTON_SEND)->EnableWindow(TRUE);
		return;
	}
//	AfxMessageBox("DLL_Net_ReadyToSendProgram");
	if(WaitForSingleObject(m_hEnableSendNextCmd,5*10000)==WAIT_TIMEOUT)
	{
		AfxMessageBox("DLL_Net_ReadyToSendProgram time out");
		GetDlgItem(IDC_BUTTON_SEND)->EnableWindow(TRUE);
		return;
	}
	ResetEvent(m_hEnableSendNextCmd);
	DLL_Net_SendProgramToPanel(cIp,31299,cProgramName,0);
//fxMessageBox("DLL_Net_SendProgramToPanel");
}

void CSendProgramInLanDlg::OnButtonSend() 
{
	// TODO: Add your control notification handler code here
	GetDlgItem(IDC_IPADDRESS_CARD_IP)->GetWindowText(m_strIpAddress);
	if(strcmp(m_strIpAddress,"")==0)
	{
		AfxMessageBox("Ip address can not be empty");		
	}
	m_ctrlProgress.SetRange(0,100);
	m_ctrlProgress.SetPos(0);
	UpdateData(TRUE);
	char cContab[20]={0};
	strcpy(cContab,"contab.txt");
	char cProgramNameDir[500]={0};
	strcpy(cProgramNameDir,m_strProjectPathName.Left(m_strProjectPathName.GetLength()-4));
	DLL_Set_Contab_File_version(0);
	DLL_Make_Contab_File(cProgramNameDir,cContab);
//	AfxMessageBox(cProgramNameDir);
//	AfxMessageBox(cContab);
	::AfxBeginThread(_Thread_Send,this,THREAD_PRIORITY_TIME_CRITICAL,0,0,NULL);
}
int CSendProgramInLanDlg::ProLedScreenWorkStatus(int iStatus,CString &strtempStatus)
{
	if((iStatus&(1<<ACK_VALUE_WORK_STATE_DISPLAY_ERROR))!=0)//ƿ쳣 
	{
		strtempStatus="Controller except!";
		return ACK_VALUE_WORK_STATE_DISPLAY_ERROR;
	}
	
	if((iStatus&(1<<ACK_VALUE_WORK_STATE_WRONG_PROGRAM_UPGRADING))!=0)//״̬
	{
		strtempStatus="POWER_OFF";
		if((iStatus&(1<<ACK_VALUE_WORK_STATE_WRONG_PROGRAM_UPGRADING))!=0)//״̬
		{
			strtempStatus="[SENDDING]";
			return ACK_VALUE_WORK_STATE_WRONG_PROGRAM_UPGRADING;
		}
		if((iStatus&(1<<ACK_VALUE_WORK_STATE_WRONG_SYSTEM_UPGRADING))!=0)//״̬ϵͳ
		{
			strtempStatus="[UPGRADING]";
			return ACK_VALUE_WORK_STATE_WRONG_SYSTEM_UPGRADING;
		}
		return ACK_VALUE_WORK_STATE_WRONG_PROGRAM_UPGRADING;
	}
	
	
	if((iStatus&(1<<ACK_VALUE_WORK_STATE_WRONG_PROGRAM_UPGRADING))!=0)//ͽĿ
	{
		strtempStatus+="SENDDING";
		return ACK_VALUE_WORK_STATE_WRONG_PROGRAM_UPGRADING;
	}
	if((iStatus&(1<<ACK_VALUE_WORK_STATE_WRONG_SYSTEM_UPGRADING))!=0)//
	{
		strtempStatus+="UPGRADING";
		return ACK_VALUE_WORK_STATE_WRONG_SYSTEM_UPGRADING;
	}
	if((iStatus&(1<<ACK_VALUE_WORK_STATE_WRONG_POWER_OFF))!=0)//ػ
	{
		strtempStatus+="POWER_OFF";
		return ACK_VALUE_WORK_STATE_WRONG_POWER_OFF;
		
	}
	if((iStatus&(1<<ACK_VALUE_WORK_STATE_WRONG_USB_DICK_PLAY))!=0)//U̲
	{
		strtempStatus+="PLAYYING PROGRAM ON USB_DISKY";
		if((iStatus&(1<<ACK_VALUE_WORK_STATE_SIZE_PRO_PANEL_NOT_SAME))!=0)
		{
			strtempStatus+="PROGRAM_SIZE is not same with PANEL SIZE";
		}
		return ACK_VALUE_WORK_STATE_WRONG_USB_DICK_PLAY;
	}
	if((iStatus&(1<<ACK_VALUE_WORK_STATE_PALY_ERROR))!=0)//Ŀ
	{
		strtempStatus+="PROGRAM_EXCEPT";
		return ACK_VALUE_WORK_STATE_PALY_ERROR;
	}
	if((iStatus&(1<<ACK_VALUE_WORK_STATE_WRONG_TESTING))!=0)
	{
		strtempStatus+="TESTING";
		return ACK_VALUE_WORK_STATE_WRONG_TESTING;
	}
	//
	strtempStatus+="PLAYING";
	if((iStatus&(1<<ACK_VALUE_WORK_STATE_SIZE_PRO_PANEL_NOT_SAME))!=0)
	{
		strtempStatus+="PROGRAM_SIZE is not same with PANEL SIZE";
	}
	return ACK_VALUE_WORK_STATE_NUM;
}
LRESULT CSendProgramInLanDlg::OnMsgPro(WPARAM wParam, LPARAM lParam)
{
	//	CString strParam1="";
	//	strParam1.Format("param1=%d",Param1);
	//	AfxMessageBox(strParam1);
	switch(wParam) 
	{

	case ENUM_COMMAND_STATISTICS_PROGRESS_BY_NET:
		{
			STRUCT_CALLBACK_NET_PORT_DATA_PACKET *pSt=(STRUCT_CALLBACK_NET_PORT_DATA_PACKET *)lParam;
			char iPrecentValue=*((char *)&pSt->pDataBuffer[0]);
//			CString strdd="";
//			strdd.Format("%d",iPrecentValue);
//			AfxMessageBox(strdd);
			if(iPrecentValue>=100)
				iPrecentValue=99;
			m_ctrlProgress.SetPos(iPrecentValue);
			m_ctrlProgress.Invalidate();
		}
		break;	
	case ENUM_COMMAND_FTP_DOWNLOAD_SUCCESS_BY_NET:
		AfxMessageBox(_T("Send ftp download command successed"));
	break;
	case ENUM_COMMAND_FTP_DOWNLOAD_FAILED_BY_NET:
		AfxMessageBox(_T("Send ftp download command failed"));

	break;
	case ENUM_COMMAND_SEND_PROGRAM_FINISHED_BY_NET:
		{
			m_ctrlProgress.SetPos(100);
			m_ctrlProgress.Invalidate();
			GetDlgItem(IDC_BUTTON_SEND)->EnableWindow(TRUE);
			AfxMessageBox("Send program finished");
		}
		break;
	case ENUM_COMMAND_SEND_PROGRAM_SUCCESS_BY_NET:
		{
			//	AfxMessageBox("ENUM_COMMAND_SEND_PROGRAM_SUCCESS_BY_COM");
			SetEvent(m_hEnableSendNextCmd);			
		}
		break;
				case ENUM_COMMAND_GET_CUR_PLAY_STATUS_SUCCESS_BY_NET:
					{ 	STRUCT_CALLBACK_NET_PORT_DATA_PACKET *pSt=(STRUCT_CALLBACK_NET_PORT_DATA_PACKET *)lParam;
						PLAY_STATE *pStPlayState=(PLAY_STATE *)&pSt->pDataBuffer[0];
						CString strTempProgramName=pStPlayState->CurrentPlayProgramName;
						AfxMessageBox(strTempProgramName);
					}
					break;

				case ENUM_COMMAND_ANYCAST_SUCCESS_BY_NET:
					{
						AfxMessageBox("anycast successed");
					}
					break;
				case 	ENUM_COMMAND_ANYCAST_FAILED_BY_NET:
					{
						AfxMessageBox("anycast failed");
					}
					break;
				case ENUM_COMMAND_ADJUST_BRIGHTNESS_FAILED_BY_NET:
					{
						AfxMessageBox("adjust brightness failed");
					}
					break;
				case ENUM_COMMAND_SWITCH_POWER_ON_FAILED_BY_NET:
					{
						AfxMessageBox("power on failed");
					}
					break;
				case ENUM_COMMAND_SWITCH_POWER_ON_SUCCESS_BY_NET:
					{
						AfxMessageBox("power on successed");
					}
					break;
				case ENUM_COMMAND_SWITCH_POWER_OFF_FAILED_BY_NET:
					{
						AfxMessageBox("power off failed");
					}
					break;
				case ENUM_COMMAND_SWITCH_POWER_OFF_SUCCESS_BY_NET:
					{
						AfxMessageBox("power off successed");
					}
					break;
				case ENUM_COMMAND_ADJUST_BRIGHTNESS_SUCCESS_BY_NET:
					{
						AfxMessageBox("adjust brightness successed");
						
					}
					break;
				case ENUM_COMMAND_GET_SYSTEM_STATUS_SUCCESS_BY_NET:
					{
						STRUCT_CALLBACK_NET_PORT_DATA_PACKET *pSt=(STRUCT_CALLBACK_NET_PORT_DATA_PACKET *)lParam;
						STRUCT_SYSTEM_STATUS st;
						memset(&st,0x00,sizeof(STRUCT_SYSTEM_STATUS));
						memcpy(&st,pSt->pDataBuffer,sizeof(STRUCT_SYSTEM_STATUS));
						CString strtempStatus="";
						CString strTempW="";
						strTempW.Format("%d,",st.iWidth);
						strTempW="Width:"+strTempW;
						CString strTempH="";
						strTempH.Format("%d\r\n",st.iHeight);
						strTempH="Height:"+strTempH;
						strtempStatus=strTempW+strTempH;
						strtempStatus+="Status:";
						CString strtempCurStatus="";
						ProLedScreenWorkStatus(st.iStatus,strtempCurStatus);
						strtempStatus+=strtempCurStatus+"\r\n";
						CString strtempDiskSize=GetMBsizeFromKB(st.iDiskSize);
						strtempDiskSize="Memory size:"+strtempDiskSize;
						strtempStatus+=strtempDiskSize;
						CString strParentVersion=BCD_To_STR(st.stVersion.iMainVer);
						CString strChildVersion=BCD_To_STR(st.stVersion.iChildVer);
						strtempStatus+="Ver:"+strParentVersion;
						CString strCarSoftVersion=BCD_To_HEX_STR(st.stCardVersion.iSoftwareVer);
						CString strCarHardVersion=BCD_To_HEX_STR(st.stCardVersion.iHardwareVer);
						strtempStatus+="[S:"+strCarSoftVersion+" H:"+strCarHardVersion+"]";
						if(st.iPasswordId!=0)
						{
							strtempStatus+="\r\nCARD_ENCRYPTED";
						}
						GetDlgItem(IDC_EDIT_STATUS)->SetWindowText(strtempStatus);	
					}
					break;
	default:
		break;
	}
	return 0;
}
void CSendProgramInLanDlg::OnClickList1(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	NMLISTVIEW *pLV = (NMLISTVIEW *)pNMHDR;
	if(pLV->iItem<0)
	{
		if(m_ctrlLinkedCardInfo1.GetItemCount()<=0)
		{
			AfxMessageBox("Check controller in lan first");
			return;
		}
		return;
	}
	POSITION pos;	
	pos = m_ctrlLinkedCardInfo1.GetFirstSelectedItemPosition();
	int m_IndexInFieldList = m_ctrlLinkedCardInfo1.GetNextSelectedItem(pos);  // õĿ	
	if(m_IndexInFieldList<0)
	{
		if(m_ctrlLinkedCardInfo1.GetItemCount()<=0)
		{
			AfxMessageBox("Check controller in lan first");
			return;
		}
		return;
	}
	int iCardCount=m_ctrlLinkedCardInfo1.GetItemCount();
	if(iCardCount<=0)
	{
		m_strControllerID="";
	}
	else if(iCardCount==1)
	{
		m_strControllerID=m_ctrlLinkedCardInfo1.GetItemText(0,0);
		m_strIpAddress=m_ctrlLinkedCardInfo1.GetItemText(0,1);
		m_ctrlIpAddress.SetWindowText(m_strIpAddress);
	}
	else
	{
		m_strControllerID=m_ctrlLinkedCardInfo1.GetItemText(m_IndexInFieldList,0);
		m_strIpAddress=m_ctrlLinkedCardInfo1.GetItemText(m_IndexInFieldList,1);
		m_ctrlIpAddress.SetWindowText(m_strIpAddress);
			
	}	
	
	*pResult = 0;
	UpdateData(FALSE);
}

void CSendProgramInLanDlg::OnButtonGetStatus() 
{
	GetDlgItem(IDC_IPADDRESS_CARD_IP)->GetWindowText(m_strIpAddress);
	if(strcmp(m_strIpAddress,"")==0)
	{
		AfxMessageBox("Ip address can not be empty");
		return;
	}
	char cIp[20]={0};
	strcpy(cIp,m_strIpAddress);
	DLL_Net_GetSystemStatus(cIp,31299,0,0);
}

void CSendProgramInLanDlg::OnButtonAdjusitBrightness() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	char cIp[20]={0};
	strcpy(cIp,m_strIpAddress);
	DLL_Net_AdjustBrightness(cIp,31299,m_uiBrightNess,0);
	
}

void CSendProgramInLanDlg::OnButtonPower() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if(m_iRadioPower<=0)
		m_iRadioPower=0;
	else
		m_iRadioPower=1;

	char cIp[20]={0};
	strcpy(cIp,m_strIpAddress);
	DLL_Net_SwitchPanel(cIp,31299,m_iRadioPower,0);//0:off 1:on
	
}

void CSendProgramInLanDlg::OnButtonAnycast() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	char cIp[20]={0};
	strcpy(cIp,m_strIpAddress);
	DLL_Net_Anycast(cIp,31299,m_uiAnycastIndex,0);
	
}
CString CSendProgramInLanDlg::GetMBsizeFromKB(int iKsize)
{
	CString strDiskSize="";
	if((iKsize>=1024)&&(iKsize<(1024*1024)))
	{
		int itemp=iKsize%1024;
		if(itemp==0)
			strDiskSize.Format("%dMB\r\n",iKsize/1024);
		else
			strDiskSize.Format("%d.%2dMB\r\n",iKsize/1024,itemp);
	}
	else if(iKsize>=(1024*1024))
	{
		int itemp=(iKsize/1024)%1024;
		if(itemp==0)
			strDiskSize.Format("%dGB\r\n",iKsize/1024/1024);
		else
			strDiskSize.Format("%d.%2dGB\r\n",iKsize/1024/1024,iKsize/1024%1024);
		
	}
	else if(iKsize<1024)
		strDiskSize.Format("%2dKB\r\n",iKsize);
	return strDiskSize;
}
CString CSendProgramInLanDlg::BCD_To_STR(int iValue)
{
	CString strtemp="";
	strtemp.Format("%d",iValue);
	return strtemp;
}
CString CSendProgramInLanDlg::BCD_To_HEX_STR(int iValue)
{
	CString strtemp="";
	strtemp.Format("%X",iValue);
	return strtemp;
}

void CSendProgramInLanDlg::OnButtonDownloadFromFtp() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	int m_uiMainVer=m_uiVersion;
	int m_uiChildVer=0x20100915;
	int m_uiProgramSize=2830;
	char cProgramName[500]={0};
	strcpy(cProgramName,m_strProgramName);
	char cIp[20]={0};
	strcpy(cIp,m_strIpAddress);
	DLL_Net_GetProgamFromFtp(cIp,31299,cProgramName,m_uiProgramSize,m_uiMainVer,m_uiChildVer,m_uiWidth,m_uiHeight);
}

void CSendProgramInLanDlg::OnButtonGetCurPlayinfo() 
{
	char cdIp[20]={0};
	strcpy(cdIp,m_strIpAddress);
	DLL_Net_GetCurPlayStatus(cdIp,31299,NULL);

}
