﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
//using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace CSharpSendProgramInWan
{
    public partial class Form1 : Form
    {
        enum ENUM_AUTH_RESULT : int
        {
            ENUM_USER_AUTH_SOCKET_ERROR = -1,
            ENUM_USER_NOT_LOGIN_SUCDESS = 0,
            ENUM_USER_NOT_EXIST = 2,
            ENUM_USER_AUTH_SUCCESS,
            ENUM_USER_PASSWORD_ERROR,
            ENUM_USER_OLD_PASSWORD_ERROR,
            ENUM_USER_NEW_PASSWORD_MODIFIED_FAILED,
            ENUM_USER_LOGIN_OTHER_PLACE,
        };
        enum ENUM_DTU_TYPE : int
        {
            ENUM_DTU_TYPE_ETUNG = 0,
            ENUM_DTU_TYPE_HONGDIAN,
            ENUM_DTU_TYPE_XIXUN,
        };
        enum ENUM_ERROR : int
        {
            ENUM_COMMAND_BEGIAN_BY_NET = 1000,
            ENUM_ERROR_INIT_SOCK = 1001,//初始化套接字错误
            ENUM_ERROR_IOCTL_SOCK = 1002,//
            ENUM_ERROR_SELECT_SOCK = 1003,//
            ENUM_ERROR_CONNECT_TIMEOUT_SOCK = 1004,//
            ENUM_ERROR_CONNECT_TIMEOUT_SOCK_GET_STATUS = 1005,//
            ENUM_ERROR_SEND_SOCK = 1006,//
            ENUM_ERROR_RECEIVE_SOCK = 1007,//
            ENUM_ERROR_RECEIVE_TIMEOUT_SOCK = 1008,//
            ENUM_ERROR_CONNECT_DATACENTER_TIMEOUT_SOCK = 1009,//
            ENUM_ERROR_CONNECT_DATACENTER_SUCCESSED = 1010,//1010
            ENUM_ERROR_DATACENTER_CLOSE_SOCK = 1011,
            ENUM_ERROR_DATACENTER_CLOSE_SOCKET_BECAUSE_AUTH_RELOGIN = 1012,
            ENUM_COMMAND_GET_SYSTEM_STATUS_FAILED_BY_NET = 1013,
            ENUM_COMMAND_GET_SYSTEM_STATUS_SUCCESS_BY_NET = 1014,
            ENUM_COMMAND_ADJUST_CLOCK_FAILED_BY_NET = 1015,
            ENUM_COMMAND_ADJUST_CLOCK_SUCCESS_BY_NET = 1016,
            ENUM_COMMAND_SWITCH_POWER_ON_FAILED_BY_NET = 1017,
            ENUM_COMMAND_SWITCH_POWER_ON_SUCCESS_BY_NET = 1018,//1018
            ENUM_COMMAND_SWITCH_POWER_OFF_FAILED_BY_NET = 1019,
            ENUM_COMMAND_SWITCH_POWER_OFF_SUCCESS_BY_NET = 1020,//1020
            ENUM_COMMAND_ADJUST_BRIGHTNESS_FAILED_BY_NET = 1021,
            ENUM_COMMAND_ADJUST_BRIGHTNESS_SUCCESS_BY_NET = 1022,
            ENUM_COMMAND_SEND_REGULAR_INSTRUCTION_FAILED_BY_NET = 1023,
            ENUM_COMMAND_SEND_REGULAR_INSTRUCTION_SUCCESS_BY_NET = 1024,
            ENUM_COMMAND_GET_REGULAR_INSTRUCTION_FAILED_BY_NET = 1025,
            ENUM_COMMAND_GET_REGULAR_INSTRUCTION_SUCCESS_BY_NET = 1026,
            ENUM_COMMAND_SEND_PROGRAM_FAILED_BY_NET = 1027,
            ENUM_COMMAND_SEND_PROGRAM_SUCCESS_BY_NET = 1028,
            ENUM_COMMAND_GET_PROGRAM_FAILED_BY_NET = 1029,
            ENUM_COMMAND_GET_PROGRAM_SUCCESS_BY_NET = 1030,
            ENUM_COMMAND_SEND_PROGRAM_FINISHED_BY_NET = 1031,
            ENUM_COMMAND_STATISTICS_PROGRESS_BY_NET = 1032,//统计发送进度
            ENUM_COMMAND_ENUM_SET_HARDWARE_PARAM_SZIE_SUCCESS_BY_NET = 1033,//0x1c调整屏幕尺寸
            ENUM_COMMAND_ENUM_SET_HARDWARE_PARAM_SZIE_FAILED_BY_NET = 1034,//0x1c调整屏幕尺寸
            ENUM_COMMAND_ENUM_SET_HARDWARE_PARAM_IP_SUCCESS_BY_NET = 1035,//0x1d设置IP
            ENUM_COMMAND_ENUM_SET_HARDWARE_PARAM_IP_FAILED_BY_NET = 1036,//0x1d设置IP
            ENUM_COMMAND_ENUM_SET_HARDWARE_PARAM_GRAY_SUCCESS_BY_NET = 1037,
            ENUM_COMMAND_ENUM_SET_HARDWARE_PARAM_GRAY_FAILED_BY_NET = 1038,
            ENUM_COMMAND_ENUM_SET_HARDWARE_PARAM_SERIAL_PORT_SUCCESS_BY_NET = 1039,//0x1e设置串口参数
            ENUM_COMMAND_ENUM_SET_HARDWARE_PARAM_SERIAL_PORT_FAILED_BY_NET = 1040,//0x1e设置串口参数
            ENUM_COMMAND_ENUM_SET_HARDWARE_EXCEPT_RESTORE_DEFAULT_PRO_SUCCESS_BY_NET = 1041,//0x1f
            ENUM_COMMAND_ENUM_SET_HARDWARE_EXCEPT_RESTORE_DEFAULT_PRO_FAILED_BY_NET = 1042,//0x1f
            ENUM_COMMAND_ENUM_SET_HARDWARE_EXCEPT_RESTORE_IP_PRO_SUCCESS_BY_NET = 1043,//0x20
            ENUM_COMMAND_ENUM_SET_HARDWARE_EXCEPT_RESTORE_IP_PRO_FAILED_BY_NET = 1044,//0x20
            ENUM_COMMAND_GET_HARDWARE_PARAM_SUCCESS_BY_NET = 1045,
            ENUM_COMMAND_GET_HARDWARE_PARAM_FAILED_BY_NET = 1046,
            ENUM_COMMAND_CONSULT_CMD_SUCCESS_BY_NET = 1047,
            ENUM_COMMAND_CONSULT_CMD_FAILD_BY_NET = 1048,
            ENUM_COMMAND_SWITCH_AUTO_TEST_SUCCESS_BY_NET = 1049,
            ENUM_COMMAND_SWITCH_AUTO_TEST_FAILED_BY_NET = 1050,
            ENUM_COMMAND_SWITCH_STOP_TEST_SUCCESS_BY_NET = 1051,
            ENUM_COMMAND_SWITCH_STOP_TEST_FAILED_BY_NET = 1052,
            ENUM_COMMAND_OPEN_LOG_SUCCESS_BY_NET = 1053,
            ENUM_COMMAND_OPEN_LOG_FAILED_BY_NET = 1054,
            ENUM_COMMAND_CLOSE_LOG_SUCCESS_BY_NET = 1055,
            ENUM_COMMAND_CLOSE_LOG_FAILED_BY_NET = 1056,
            ENUM_COMMAND_GET_LOG_FAILED_BY_NET = 1057,
            ENUM_COMMAND_GET_LOG_SUCCESS_BY_NET = 1058,
            ENUM_COMMAND_SET_INTERNET_PORT_SUCCESS_BY_NET = 1059,
            ENUM_COMMAND_SET_INTERNET_PORT_FAILED_BY_NET = 1060,
            ENUM_COMMAND_STATISTICS_PROGRESS_RESEND_INDEX_BY_NET = 1061,
            ENUM_COMMAND_GET_SYSTEM_STATUS_ENABLE_SEND_BY_NET = 1062,
            ENUM_COMMAND_SET_SERIAL_ID_SUCCESS_BY_NET = 1063,
            ENUM_COMMAND_SET_SERIAL_ID_FAILED_BY_NET = 1064,
            ENUM_COMMAND_ANYCAST_SUCCESS_BY_NET = 1065,
            ENUM_COMMAND_ANYCAST_FAILED_BY_NET = 1066,
            ENUM_COMMAND_ADD_PASSWORD_SUCCESS_BY_NET = 1067,
            ENUM_COMMAND_ADD_PASSWORD_FAILED_BY_NET = 1068,
            ENUM_COMMAND_CANCLE_PASSWORD_SUCCESS_BY_NET = 1069,
            ENUM_COMMAND_CANCLE_PASSWORD_FAILED_BY_NET = 1070,
            ENUM_COMMAND_GET_HARDWARE_PARAM_BY_NET = 1071,
            ENUM_COMMAND_SET_DNS_FIXEDIP_SUCCESSED_BY_NET = 1072,
            ENUM_COMMAND_SET_DNS_FIXEDIP_FAILED_BY_NET = 1073,
            ENUM_COMMAND_CLIENT_LOGEIN_HOST_BY_NET = 1074,
            ENUM_COMMAND_SET_VALIDITY_SUCCESS_BY_NET = 1075,
            ENUM_COMMAND_SET_VALIDITY_FAILED_BY_NET = 1076,
            ENUM_COMMAND_GET_VALIDITY_SUCCESS_BY_NET = 1077,
            ENUM_COMMAND_UPGRADE_CARD_SOFT_STATISTICS_PROGRESS_BY_NET = 1078,
            ENUM_COMMAND_NET_COMMU_TYPE_UPGRADE_FINISHED_EXIT = 1079,
            ENUM_COMMAND_GET_HCP_SUCCESS_BY_NET = 1080,//
            ENUM_COMMAND_SET_MASTER_SUCCESSED_BY_NET = 1081,
            ENUM_COMMAND_SET_MASTER_FAILED_BY_NET = 1082,
            ENUM_COMMAND_SEND_FONT_STATISTICS_PROGRESS_BY_NET = 1083,
            ENUM_COMMAND_FONT_CONSULT_CMD_FAILD_BY_NET = 1084,
            ENUM_COMMAND_FONT_SYN_CMD_FINISHED_BY_NET = 1085,
            ENUM_COMMAND_SET_APN_SUCCESSED_BY_NET = 1086,
            ENUM_COMMAND_SET_APN_FAILED_BY_NET = 1087,
            ENUM_COMMAND_SET_ATCMD_SUCCESSED_BY_NET = 1088,
            ENUM_COMMAND_SET_ATCMD_FAILED_BY_NET = 1089,
            ENUM_COMMAND_SET_DHCP_SUCCESS_BY_NET = 1090,
            ENUM_COMMAND_SET_DHCP_FAILED_BY_NET = 1091,
            ENUM_COMMAND_SET_FTP_SUCCESS_BY_NET = 1092,
            ENUM_COMMAND_SET_FTP_FAILED_BY_NET = 1093,
            ENUM_COMMAND_SET_CROSS_DISPLAY_SUCCESS_BY_NET = 1094,
            ENUM_COMMAND_SET_CROSS_DISPLAY_FAILED_BY_NET = 1095,
            ENUM_COMMAND_GET_CUR_PLAY_STATUS_SUCCESS_BY_NET = 1096,
            ENUM_COMMAND_GET_CUR_PLAY_STATUS_FAILED_BY_NET = 1097,
            ENUM_COMMAND_SET_CLOSE_TIMER_INTERNET_SUCCESS_BY_NET = 1098,
            ENUM_COMMAND_SET_OPEN_TIMER_INTERNET_SUCCESS_BY_NET = 1099,
            ENUM_COMMAND_SEND_FILE_HEAD_ANSWER_ERROR_BY_NET = 1100,
            ENUM_COMMAND_FTP_DOWNLOAD_SUCCESS_BY_NET = 1101,
            ENUM_COMMAND_FTP_DOWNLOAD_FAILED_BY_NET = 1102,
            ENUM_COMMAND_END_BY_NET,

            ENUM_COMMAND_BEGIAN_BY_COM = 2000,
            ENUM_COMMAND_OPEN_COM_PORT_FAILED = 2001,
            ENUM_COMMAND_GET_SYSTEM_STATUS_FAILED_BY_COM = 2002,
            ENUM_COMMAND_GET_SYSTEM_STATUS_SUCCESS_BY_COM = 2003,
            ENUM_COMMAND_ADJUST_CLOCK_FAILED_BY_COM = 2004,
            ENUM_COMMAND_ADJUST_CLOCK_SUCCESS_BY_COM = 2005,
            ENUM_COMMAND_SWITCH_POWER_ON_FAILED_BY_COM = 2006,
            ENUM_COMMAND_SWITCH_POWER_ON_SUCCESS_BY_COM = 2007,
            ENUM_COMMAND_SWITCH_POWER_OFF_FAILED_BY_COM = 2008,
            ENUM_COMMAND_SWITCH_POWER_OFF_SUCCESS_BY_COM = 2009,
            ENUM_COMMAND_ADJUST_BRIGHTNESS_FAILED_BY_COM = 2010,//2010
            ENUM_COMMAND_ADJUST_BRIGHTNESS_SUCCESS_BY_COM = 2011,
            ENUM_COMMAND_SEND_REGULAR_INSTRUCTION_FAILED_BY_COM = 2012,
            ENUM_COMMAND_SEND_REGULAR_INSTRUCTION_SUCCESS_BY_COM = 2013,
            ENUM_COMMAND_GET_REGULAR_INSTRUCTION_FAILED_BY_COM = 2014,
            ENUM_COMMAND_GET_REGULAR_INSTRUCTION_SUCCESS_BY_COM = 2015,
            ENUM_COMMAND_SEND_PROGRAM_FAILED_BY_COM = 2016,
            ENUM_COMMAND_SEND_PROGRAM_SUCCESS_BY_COM = 2017,
            ENUM_COMMAND_GET_PROGRAM_FAILED_BY_COM = 2018,
            ENUM_COMMAND_GET_PROGRAM_SUCCESS_BY_COM = 2019,
            ENUM_COMMAND_SEND_PROGRAM_FINISHED_BY_COM = 2020,//2020
            ENUM_COMMAND_STATISTICS_PROGRESS_BY_COM = 2021,//统计发送进度
            ENUM_COMMAND_STATISTICS_PROGRESS_UPGRADEFIRMWARE_BY_COM = 2022,
            ENUM_COMMAND_UPGRADE_FINISHED_EXIT_BY_COM = 2023,
            ENUM_COMMAND_ENUM_SET_HARDWARE_PARAM_SZIE_SUCCESS_BY_COM = 2024,//0x1c调整屏幕尺寸
            ENUM_COMMAND_ENUM_SET_HARDWARE_PARAM_SZIE_FAILED_BY_COM = 2025,//0x1c调整屏幕尺寸
            ENUM_COMMAND_ENUM_SET_HARDWARE_PARAM_IP_SUCCESS_BY_COM = 2026,//0x1d设置IP
            ENUM_COMMAND_ENUM_SET_HARDWARE_PARAM_IP_FAILED_BY_COM = 2027,//0x1d设置IP
            ENUM_COMMAND_ENUM_SET_HARDWARE_PARAM_GRAY_SUCCESS_BY_COM = 2028,
            ENUM_COMMAND_ENUM_SET_HARDWARE_PARAM_GRAY_FAILED_BY_COM = 2029,
            ENUM_COMMAND_ENUM_SET_HARDWARE_PARAM_SERIAL_PORT_SUCCESS_BY_COM = 2030,//0x1e设置串口参数
            ENUM_COMMAND_ENUM_SET_HARDWARE_PARAM_SERIAL_PORT_FAILED_BY_COM = 2031,//0x1e设置串口参数
            ENUM_COMMAND_ENUM_SET_HARDWARE_EXCEPT_RESTORE_DEFAULT_PRO_SUCCESS_BY_COM = 2032,//2032
            ENUM_COMMAND_ENUM_SET_HARDWARE_EXCEPT_RESTORE_DEFAULT_PRO_FAILED_BY_COM = 2033,//0x1f
            ENUM_COMMAND_ENUM_SET_HARDWARE_EXCEPT_RESTORE_IP_PRO_SUCCESS_BY_COM = 2034,//0x20
            ENUM_COMMAND_ENUM_SET_HARDWARE_EXCEPT_RESTORE_IP_PRO_FAILED_BY_COM = 2035,//0x20
            ENUM_COMMAND_GET_HARDWARE_PARAM_SUCCESS_BY_COM = 2036,
            ENUM_COMMAND_GET_HARDWARE_PARAM_FAILED_BY_COM = 2037,
            ENUM_COMMAND_CONSULT_CMD_SUCCESS_BY_COM = 2038,
            ENUM_COMMAND_CONSULT_CMD_FAILD_BY_COM = 2039,
            ENUM_COMMAND_SWITCH_AUTO_TEST_SUCCESS_BY_COM = 2040,//2040
            ENUM_COMMAND_SWITCH_AUTO_TEST_FAILED_BY_COM = 2041,
            ENUM_COMMAND_SWITCH_STOP_TEST_SUCCESS_BY_COM = 2042,//2042
            ENUM_COMMAND_SWITCH_STOP_TEST_FAILED_BY_COM = 2043,
            ENUM_COMMAND_OPEN_LOG_SUCCESS_BY_COM = 2044,
            ENUM_COMMAND_OPEN_LOG_FAILED_BY_COM = 2045,
            ENUM_COMMAND_CLOSE_LOG_SUCCESS_BY_COM = 2046,
            ENUM_COMMAND_CLOSE_LOG_FAILED_BY_COM = 2047,
            ENUM_COMMAND_GET_LOG_FAILED_BY_COM = 2048,
            ENUM_COMMAND_GET_LOG_SUCCESS_BY_COM = 2049,
            ENUM_COMMAND_SET_INTERNET_PORT_SUCCESS_BY_COM = 2050,
            ENUM_COMMAND_SET_INTERNET_PORT_FAILED_BY_COM = 2051,
            ENUM_COMMAND_STATISTICS_PROGRESS_RESEND_INDEX_BY_COM = 2052,//2052
            ENUM_COMMAND_GET_SYSTEM_STATUS_ENABLE_SEND_BY_COM = 2053,
            ENUM_COMMAND_SET_SERIAL_ID_SUCCESS_BY_COM = 2054,
            ENUM_COMMAND_SET_SERIAL_ID_FAILED_BY_COM = 2055,
            ENUM_COMMAND_ANYCAST_SUCCESS_BY_COM = 2056,//2056
            ENUM_COMMAND_ANYCAST_FAILED_BY_COM = 2057,//2057
            ENUM_COMMAND_ADD_PASSWORD_SUCCESS_BY_COM = 2058,
            ENUM_COMMAND_ADD_PASSWORD_FAILED_BY_COM = 2059,
            ENUM_COMMAND_CANCLE_PASSWORD_SUCCESS_BY_COM = 2060,
            ENUM_COMMAND_CANCLE_PASSWORD_FAILED_BY_COM = 2061,
            ENUM_COMMAND_SET_DNS_FIXEDIP_SUCCESSED_BY_COM = 2062,//2062
            ENUM_COMMAND_SET_DNS_FIXEDIP_FAILED_BY_COM = 2063,
            ENUM_COMMAND_CLIENT_LOGEIN_HOST_BY_COM = 2064,
            ENUM_COMMAND_SET_VALIDITY_SUCCESS_BY_COM = 2065,
            ENUM_COMMAND_SET_VALIDITY_FAILED_BY_COM = 2066,
            ENUM_COMMAND_GET_VALIDITY_SUCCESS_BY_COM = 2067,
            ENUM_COMMAND_GET_GPRS_DTU_STATUS_NOSUCHDTU = 2068,
            ENUM_COMMAND_GET_GPRS_DTU_STATUS_ONLINE = 2069,
            ENUM_COMMAND_GET_GPRS_DTU_STATUS_OFFLINE = 2070,
            ENUM_COMMAND_GET_XIXUN_DTU_STATUS_NOSUCHDTU = 2071,
            ENUM_COMMAND_GET_XIXUN_DTU_STATUS_ONLINE = 2072,//2072
            ENUM_COMMAND_GET_XIXUN_DTU_STATUS_OFFLINE = 2073,
            ENUM_COMMAND_SET_MASTER_SUCCESSED_BY_COM = 2074,
            ENUM_COMMAND_SET_MASTER_FAILED_BY_COM = 2075,
            ENUM_COMMAND_SET_DHCP_SUCCESS_BY_COM = 2076,
            ENUM_COMMAND_SET_DHCP_FAILED_BY_COM = 2077,
            ENUM_COMMAND_FTP_DOWNLOAD_SUCCESS_BY_COM = 2078,
            ENUM_COMMAND_FTP_DOWNLOAD_FAILED_BY_COM = 2079,
            ENUM_COMMAND_SET_FTP_SUCCESS_BY_COM = 2080,
            ENUM_COMMAND_SET_FTP_FAILED_BY_COM = 2081,
            ENUM_COMMAND_GET_CUR_PLAY_STATUS_SUCCESS_BY_COM = 2082,//2082
            ENUM_COMMAND_COMMUNICATION_TCP_LEDDATASERVER = 2083,
            ENUM_COMMAND_COMMUNICATION_UDP_LEDDATASERVER = 2084,
            ENUM_COMMAND_COMMUNICATION_TCP_P2P = 2085,
            ENUM_COMMAND_COMMUNICATION_P2P_TCP = 2086,
            ENUM_COMMAND_COMMUNICATION_UDP_HOLE = 2087,
            ENUM_COMMAND_LEDDATASERVER_HOLE_PORT_FAILED = 2088,
            ENUM_COMMAND_END_BY_COM,


        };
        private InterfaceDll m_interface;
        public int m_iLinkServerSuccess=-1;
        public int m_iAuthResult = -1;
        public string m_strProjectPathName="";
        public int m_iEnableSendProgrameFlag=0;
        public string m_curSelectedImei = "";
        private  OpenFileDialog openFileDialog1;
        public Form1()
        {
            InitializeComponent();
            m_interface = new InterfaceDll(this.Handle, Application.StartupPath);
            m_interface.Call_DLL_Net_Init();
            m_interface.InitCallBackFunc();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            textBoxServerAddress.Text = "58.247.9.162";
            textBoxPort.Text = "50000";
            textBoxUserName.Text = "test";
            textBoxPassword.Text = "888";
        }

        private void buttonLogin_Click(object sender, EventArgs e)
        {
            m_iLinkServerSuccess=m_interface.Call_DLL_GPRS_Link_Server(textBoxServerAddress.Text.ToString(), ushort.Parse(textBoxPort.Text), 0,(int)ENUM_DTU_TYPE.ENUM_DTU_TYPE_XIXUN, "");
	        if(m_iLinkServerSuccess<=0)
	        {
		        MessageBox.Show("Link LedDataServer failed");
	        }
	        else
	        {
		        //char cAuth[100]={0};
		        //strcpy(cAuth,m_strUserName);
		        //char cAuthPassword[10]={0};
		        //strcpy(cAuthPassword,m_strPassword);
                m_iAuthResult = m_interface.Call_DLL_GPRS_Auth(textBoxUserName.Text.ToString(), textBoxPassword.Text.ToString(), (int)ENUM_DTU_TYPE.ENUM_DTU_TYPE_XIXUN);
		        switch(m_iAuthResult)
		        {
			        case (int)ENUM_AUTH_RESULT.ENUM_USER_AUTH_SUCCESS:
					        MessageBox.Show("login successed");
				        break;
                    case (int)ENUM_AUTH_RESULT.ENUM_USER_AUTH_SOCKET_ERROR:
				        MessageBox.Show("login socket error");
				        break;
                    case (int)ENUM_AUTH_RESULT.ENUM_USER_NOT_LOGIN_SUCDESS:
				        MessageBox.Show("login failed");
				        break;
                    case (int)ENUM_AUTH_RESULT.ENUM_USER_NOT_EXIST:
				        MessageBox.Show("user name is not exist");
				        break;
                    case (int)ENUM_AUTH_RESULT.ENUM_USER_PASSWORD_ERROR:
				        MessageBox.Show("password error");
				        break;
                    case (int)ENUM_AUTH_RESULT.ENUM_USER_LOGIN_OTHER_PLACE:
				        MessageBox.Show("user re_login");
				        break;
				
		        }
			
	        }       
        }

        private void button3_Click(object sender, EventArgs e)
        {
            switch (m_iAuthResult)
            {
                case (int)ENUM_AUTH_RESULT.ENUM_USER_AUTH_SUCCESS:
                case (int)ENUM_AUTH_RESULT.ENUM_USER_LOGIN_OTHER_PLACE:
                    listViewControllerInfo.Items.Clear();
                    m_interface.Call_DLL_Xixun_Get_All_Dtu_Imei_Status();
                    break;
                default:
                    MessageBox.Show("please Login first");
                    break;
            } ;
        }
        protected override void WndProc(ref Message m)
        {
            // Bitmap BAgg1;
            //Graphics gGGG = Graphics.FromImage(BAgg2);
            //gGGG.Clear(Color.Transparent);
            // g.Clear(Color.Blue);

            switch (m.Msg)
            {
                case 2000://handle
                    switch ((int)(m.WParam))
                    {
                        case (int)ENUM_ERROR.ENUM_ERROR_CONNECT_DATACENTER_TIMEOUT_SOCK:
                                 MessageBox.Show("link server timeout");
                            break;
                        case (int)ENUM_ERROR.ENUM_ERROR_CONNECT_DATACENTER_SUCCESSED:
                            break;
                        case (int)ENUM_ERROR.ENUM_COMMAND_GET_XIXUN_DTU_STATUS_ONLINE:
                            string strImei = Marshal.PtrToStringAnsi((IntPtr)m.LParam, 16);
                            int iIndex=-1;
                            for(int i=0;i<listViewControllerInfo.Items.Count;i++)
                            {
                                if(strImei==listViewControllerInfo.Items[i].SubItems[0].Text.ToString())
                                {
                                    iIndex=i;
                                    break;
                                }
                            }
                            if (iIndex == -1)
                            {
                                ListViewItem lvi = new ListViewItem();
                                lvi.ImageIndex = -1;     //通过与imageList绑定，显示imageList中第i项图标    
                                lvi.Text = strImei;
                                lvi.SubItems.Add("online");
                                lvi.SubItems.Add("");
                                this.listViewControllerInfo.Items.Add(lvi);
                                m_interface.Call_DLL_GPRS_Get_Imei_Status(strImei, (int)ENUM_DTU_TYPE.ENUM_DTU_TYPE_XIXUN, 0, 0, 0);
                          }
                            else
                            {
                                this.listViewControllerInfo.Items[iIndex].SubItems[1].Text = "online";
  
                            }



  
                            break;
                        case (int)ENUM_ERROR.ENUM_COMMAND_GET_XIXUN_DTU_STATUS_OFFLINE:
                            break;
                        case (int)ENUM_ERROR.ENUM_COMMAND_GET_SYSTEM_STATUS_ENABLE_SEND_BY_COM:
                            {
                                m_iEnableSendProgrameFlag = 1;
                            }
                            break;
                        case (int)ENUM_ERROR.ENUM_COMMAND_SEND_PROGRAM_SUCCESS_BY_COM:
                            {
                                m_iEnableSendProgrameFlag = 2;
                            }
                            break;
                        case (int)ENUM_ERROR.ENUM_COMMAND_GET_SYSTEM_STATUS_SUCCESS_BY_COM:
                            {
                                string strTempImei = Marshal.PtrToStringAnsi((IntPtr)m.LParam, 16);
                                Int32[] tempValue = new Int32[68];
                                Marshal.Copy(m.LParam, tempValue, 0, 68);
                                //string strWidth = GetStringFromLanguageXmlFile("IDS_Width") + tempValue[6].ToString();
                                //string strHeight = GetStringFromLanguageXmlFile("IDS_Height") + tempValue[7].ToString();
                                string strstatue = "";
                                ProLedScreenWorkStatus(tempValue[9], strTempImei);

                            }
                            break;
                        case (int)ENUM_ERROR.ENUM_COMMAND_SEND_PROGRAM_FINISHED_BY_COM:
                            {
                                progressBar1.Value = 100;
                               MessageBox.Show("Send program finished");

                            }
                            break;
                        case (int)ENUM_ERROR.ENUM_COMMAND_STATISTICS_PROGRESS_BY_COM:
                            {
                                Int32[] tempValue = new Int32[68];
                                Marshal.Copy(m.LParam, tempValue, 0, 68);
                                int iPrecentValue = tempValue[7];
                                if (iPrecentValue >= 100)
                                    iPrecentValue = 99;
                                progressBar1.Value = iPrecentValue;
 
                            }
                            break;
                    }
                  break;
            }
            base.WndProc(ref m);
        }

        private void button1_Click(object sender, EventArgs e)
        {
           this.openFileDialog1 = new OpenFileDialog();
 //           this.openFileDialog1.InitialDirectory = "c:\\";
            this.openFileDialog1.Filter = "project files (*.xml)|*.xml";
            this.openFileDialog1.FilterIndex = 1;
            this.openFileDialog1.RestoreDirectory = false;
            this.openFileDialog1.Multiselect = false;
            this.openFileDialog1.Title ="Select project file";

            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                string strFileName = this.openFileDialog1.FileName;
                textBoxProjectPath.Text = strFileName;
            }
        }
        enum enum__ACK_VALUE_WORK_STATE_BIT_MAP//获取系统状态
        {
            ACK_VALUE_WORK_STATE_PALY_ERROR,				// D0:0--播放正常，1--节目异常。
            ACK_VALUE_WORK_STATE_DISPLAY_ERROR,				// D1:0--显示正常，1--硬件显示异常。
            ACK_VALUE_WORK_STATE_WRONG_USB_DICK_PLAY,		// D2:1--优盘播放。
            ACK_VALUE_WORK_STATE_WRONG_PROGRAM_UPGRADING,	// D3:1--节目升级中。
            ACK_VALUE_WORK_STATE_WRONG_SYSTEM_UPGRADING,	// D4:1--系统升级中。
            ACK_VALUE_WORK_STATE_WRONG_TESTING,				// D5:1--系统测试中。
            ACK_VALUE_WORK_STATE_WRONG_POWER_OFF,			// D6:1--电源关机。
            ACK_VALUE_WORK_STATE_SIZE_PRO_PANEL_NOT_SAME,
            ACK_VALUE_WORK_STATE_NUM
        };
        int ProLedScreenWorkStatus(int iStatus, string strImei)
        {
            int iIndex=-1;
            for(int i=0;i<listViewControllerInfo.Items.Count;i++)
            {
                if(strImei==listViewControllerInfo.Items[i].SubItems[0].Text.ToString())
                {
                    iIndex=i;
                    break;
                }
            }

            if(iIndex==-1)
                return -1;

            if ((iStatus & (1 << (int)enum__ACK_VALUE_WORK_STATE_BIT_MAP.ACK_VALUE_WORK_STATE_DISPLAY_ERROR)) != 0)//控制卡异常 
            {
                listViewControllerInfo.Items[iIndex].SubItems[2].Text = "except"; 
               return (int)enum__ACK_VALUE_WORK_STATE_BIT_MAP.ACK_VALUE_WORK_STATE_DISPLAY_ERROR;
            }

            if ((iStatus & (1 << (int)enum__ACK_VALUE_WORK_STATE_BIT_MAP.ACK_VALUE_WORK_STATE_WRONG_PROGRAM_UPGRADING)) != 0)//关屏状态
            {
                if ((iStatus & (1 << (int)enum__ACK_VALUE_WORK_STATE_BIT_MAP.ACK_VALUE_WORK_STATE_WRONG_PROGRAM_UPGRADING)) != 0)//关屏状态正在升级
                {
                    listViewControllerInfo.Items[iIndex].SubItems[2].Text = "Sending program";
                    return (int)enum__ACK_VALUE_WORK_STATE_BIT_MAP.ACK_VALUE_WORK_STATE_WRONG_PROGRAM_UPGRADING;
                }
                if ((iStatus & (1 << (int)enum__ACK_VALUE_WORK_STATE_BIT_MAP.ACK_VALUE_WORK_STATE_WRONG_SYSTEM_UPGRADING)) != 0)//关屏状态系统升级
                {
                    listViewControllerInfo.Items[iIndex].SubItems[2].Text = "Upgrading firmware";
                    return (int)enum__ACK_VALUE_WORK_STATE_BIT_MAP.ACK_VALUE_WORK_STATE_WRONG_SYSTEM_UPGRADING;
                }
                return (int)enum__ACK_VALUE_WORK_STATE_BIT_MAP.ACK_VALUE_WORK_STATE_WRONG_PROGRAM_UPGRADING;
            }


            if ((iStatus & (1 << (int)enum__ACK_VALUE_WORK_STATE_BIT_MAP.ACK_VALUE_WORK_STATE_WRONG_PROGRAM_UPGRADING)) != 0)//发送节目中
            {
                listViewControllerInfo.Items[iIndex].SubItems[2].Text = "Sending program";
                return (int)enum__ACK_VALUE_WORK_STATE_BIT_MAP.ACK_VALUE_WORK_STATE_WRONG_PROGRAM_UPGRADING;
            }
            if ((iStatus & (1 << (int)enum__ACK_VALUE_WORK_STATE_BIT_MAP.ACK_VALUE_WORK_STATE_WRONG_SYSTEM_UPGRADING)) != 0)//升级中
            {
                listViewControllerInfo.Items[iIndex].SubItems[2].Text = "Upgrading firmware";
                return (int)enum__ACK_VALUE_WORK_STATE_BIT_MAP.ACK_VALUE_WORK_STATE_WRONG_SYSTEM_UPGRADING;
            }
            if ((iStatus & (1 << (int)enum__ACK_VALUE_WORK_STATE_BIT_MAP.ACK_VALUE_WORK_STATE_WRONG_POWER_OFF)) != 0)//关机
            {
                listViewControllerInfo.Items[iIndex].SubItems[2].Text = "power off";
                return (int)enum__ACK_VALUE_WORK_STATE_BIT_MAP.ACK_VALUE_WORK_STATE_WRONG_POWER_OFF;

            }
            if ((iStatus & (1 << (int)enum__ACK_VALUE_WORK_STATE_BIT_MAP.ACK_VALUE_WORK_STATE_WRONG_USB_DICK_PLAY)) != 0)//U盘播放
            {
                listViewControllerInfo.Items[iIndex].SubItems[2].Text = "playing u-disk";
                 return (int)enum__ACK_VALUE_WORK_STATE_BIT_MAP.ACK_VALUE_WORK_STATE_WRONG_USB_DICK_PLAY;
            }
            if ((iStatus & (1 << (int)enum__ACK_VALUE_WORK_STATE_BIT_MAP.ACK_VALUE_WORK_STATE_PALY_ERROR)) != 0)//节目错误
            {
                listViewControllerInfo.Items[iIndex].SubItems[2].Text = "play error";
                return (int)enum__ACK_VALUE_WORK_STATE_BIT_MAP.ACK_VALUE_WORK_STATE_PALY_ERROR;
            }
            if ((iStatus & (1 << (int)enum__ACK_VALUE_WORK_STATE_BIT_MAP.ACK_VALUE_WORK_STATE_WRONG_TESTING)) != 0)
            {
                listViewControllerInfo.Items[iIndex].SubItems[2].Text = "testing";
                return (int)enum__ACK_VALUE_WORK_STATE_BIT_MAP.ACK_VALUE_WORK_STATE_WRONG_TESTING;
            }
            //正常播放
            listViewControllerInfo.Items[iIndex].SubItems[2].Text = "Playing";
            return (int)enum__ACK_VALUE_WORK_STATE_BIT_MAP.ACK_VALUE_WORK_STATE_NUM;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (m_curSelectedImei=="")
            {
                MessageBox.Show("please select controller first");
                return;
            }
            if(textBoxProjectPath.Text=="")
            {
                MessageBox.Show("please select xml project file first");
                return;
            }
            this.backgroundWorker1.RunWorkerAsync();
 

        }

        private void button4_Click(object sender, EventArgs e)
        {
            string cImei = m_curSelectedImei;
            IntPtr iHandle = m_interface.Call_DLL_GPRS_GetClassHandle(cImei, (int)ENUM_DTU_TYPE.ENUM_DTU_TYPE_XIXUN);
            if (iHandle != IntPtr.Zero)
            {
                m_interface.Call_DLL_GPRS_GetSystemStatus(iHandle, 0x00, 0x00, 0x00, 0x00, "");
            }

        }

        private void listViewControllerInfo_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (listViewControllerInfo.SelectedItems.Count > 0)
            {
                m_curSelectedImei = listViewControllerInfo.SelectedItems[0].SubItems[0].Text.ToString();
            }
            else
            {
            }
        }

        private void backgroundWorker1_DoWork(object sender, DoWorkEventArgs e)
        {
            if (backgroundWorker1.CancellationPending)
            {
                e.Cancel = true;
            }
            else
            {
                string cContab = "contab.txt";
                if (textBoxProjectPath.Text.ToString() != "")
                {
                    m_strProjectPathName = textBoxProjectPath.Text.ToString();
                    string cProgramNameDir = m_strProjectPathName.Substring(0, m_strProjectPathName.Length - 4);
                    m_interface.Call_DLL_Make_Contab_File(cProgramNameDir, cContab);
                }
                progressBar1.Minimum = 0;
                progressBar1.Maximum = 100;
                progressBar1.Value = 1;
                UInt32 m_uiMainVer = 9;
                UInt32 m_uiChildVer = 0x20100915;
                switch (m_iAuthResult)
                {
                    case (int)ENUM_AUTH_RESULT.ENUM_USER_AUTH_SUCCESS:
                    case (int)ENUM_AUTH_RESULT.ENUM_USER_LOGIN_OTHER_PLACE:
                        {
                            string cProgramName = m_strProjectPathName;
                            string cImei = m_curSelectedImei;
                            IntPtr iHandle = m_interface.Call_DLL_GPRS_GetClassHandle(cImei, (int)ENUM_DTU_TYPE.ENUM_DTU_TYPE_XIXUN);

                            if (iHandle != IntPtr.Zero)
                            {
                                m_iEnableSendProgrameFlag = 0;
                                m_interface.Call_DLL_GPRS_GetSystemStatus(iHandle, 0, 0, 0x80, 0x01, "");

                                int itempCount = 0;
                                while (m_iEnableSendProgrameFlag == 0)
                                {
                                    System.Threading.Thread.Sleep(100);
                                    itempCount++;
                                    if (itempCount > 500)
                                    {
                                        itempCount = -1;
                                        break;
                                    }
                                }
                                if (m_iEnableSendProgrameFlag != 1)
                                {

                                    MessageBox.Show(itempCount.ToString() + "send program to controller failed," + m_iEnableSendProgrameFlag.ToString());
                                    return;
                                }
                                string sType=m_curSelectedImei.Substring(0,1);
                                sType.ToLower();
                                if (sType == "a" || sType == "c" || sType == "m")
                                {  m_uiMainVer = 9;
                                    textBox1.Text="9";
                                }
                                else if (sType == "k")
                                {
                                    m_uiMainVer = 10;
                                    textBox1.Text = "10";
                                }
                                else
                                {
                                    if (textBox1.Text == "")
                                    {
                                        MessageBox.Show("version can not be empty");
                                        return;
                                    }
                                    m_uiMainVer = UInt32.Parse(textBox1.Text);
                                }
                                m_interface.Call_DLL_GPRS_ReadyToSendProgram(iHandle, cProgramName, m_uiMainVer, m_uiChildVer);
                                itempCount = 0;
                                while (m_iEnableSendProgrameFlag == 1)
                                {
                                    System.Threading.Thread.Sleep(100);
                                    itempCount++;
                                    if (itempCount > 500)
                                    {
                                        itempCount = -1;
                                        break;
                                    }
                                }
                                if (m_iEnableSendProgrameFlag != 2)
                                {
                                    MessageBox.Show("send program to controller failed!," + m_iEnableSendProgrameFlag.ToString());
                                    return;
                                }
                                m_interface.Call_DLL_GPRS_SendProgramToPanel(iHandle, cProgramName);
                            }
                        }

                        break;
                    default:
                        MessageBox.Show("please Login first");
                        break;

                }
            }
        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {

        }

    }
}
