// TestEncodeMaterialDllDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TestEncodeMaterialDll.h"
#include "TestEncodeMaterialDllDlg.h"
#include "EncodeMaterial.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestEncodeMaterialDllDlg dialog

CTestEncodeMaterialDllDlg::CTestEncodeMaterialDllDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestEncodeMaterialDllDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTestEncodeMaterialDllDlg)
	m_strTemperatureHumidityFilePathName = _T("");
	m_strDigitalClockFilePathName = _T("");
	m_strAnalogClockFilePathName = _T("");
	m_strLxdFilePathName = _T("");
	m_strXmlFilePathName = _T("");
	m_strTimerFilePathName = _T("");
	m_strTxtFilePathName = _T("");
	m_strTxtXrsFilePathName = _T("");
	m_strRtfFilePathName = _T("");
	m_strRtfXrsFilePathName = _T("");
	m_strStringXrsFilePathName = _T("");
	m_strStringContent = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTestEncodeMaterialDllDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTestEncodeMaterialDllDlg)
	DDX_Text(pDX, IDC_EDIT_TH_FILE_PATHNAME, m_strTemperatureHumidityFilePathName);
	DDX_Text(pDX, IDC_EDIT_DIGITALCLOCK_FILE_PATHNAME, m_strDigitalClockFilePathName);
	DDX_Text(pDX, IDC_EDIT_ANALOGCLOCK_FILE_PATHNAME, m_strAnalogClockFilePathName);
	DDX_Text(pDX, IDC_EDIT_LXD, m_strLxdFilePathName);
	DDX_Text(pDX, IDC_EDIT_XML, m_strXmlFilePathName);
	DDX_Text(pDX, IDC_EDIT_TIMER_FILE_PATHNAME, m_strTimerFilePathName);
	DDX_Text(pDX, IDC_EDIT_TXT_FILE, m_strTxtFilePathName);
	DDX_Text(pDX, IDC_EDIT_TXT_XRS, m_strTxtXrsFilePathName);
	DDX_Text(pDX, IDC_EDIT_RTF_FILE, m_strRtfFilePathName);
	DDX_Text(pDX, IDC_EDIT_RTF_XRS, m_strRtfXrsFilePathName);
	DDX_Text(pDX, IDC_EDIT_RTF_XRS2, m_strStringXrsFilePathName);
	DDX_Text(pDX, IDC_EDIT_STRING_CONTENT, m_strStringContent);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTestEncodeMaterialDllDlg, CDialog)
	//{{AFX_MSG_MAP(CTestEncodeMaterialDllDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	ON_BN_CLICKED(IDC_BUTTON5, OnButton5)
	ON_BN_CLICKED(IDC_BUTTON_TXT_TO_XRS, OnButtonTxtToXrs)
	ON_BN_CLICKED(IDC_BUTTON_RTF_TO_XRS, OnButtonRtfToXrs)
	ON_BN_CLICKED(IDC_BUTTON6, OnButton6)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestEncodeMaterialDllDlg message handlers
CString GetAppPath()
{
	CString m_sCPath,str ;
	char dir[300] ;
	HINSTANCE hpin= AfxGetInstanceHandle() ;
	GetModuleFileName(hpin,dir,299);
	m_sCPath = dir ;//ǰ·
	str =  AfxGetApp()->m_pszExeName;
	str = str+".exe" ;
	m_sCPath.MakeLower() ;
	str.MakeLower() ;
	int ipos ;
	ipos  =  m_sCPath.Find(str ) ;
	m_sCPath.Delete(ipos ,str.GetLength()) ;  
	if ( m_sCPath.Right(1)!='\\')
	{
		m_sCPath =  m_sCPath+"\\" ;
	}
	return m_sCPath ;
}
BOOL CTestEncodeMaterialDllDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	StartupEncodeMaterial();	
	CString strSaveDir=GetAppPath();
	m_strTemperatureHumidityFilePathName =strSaveDir+ _T("TemperatureHumidity.xrs");
	m_strDigitalClockFilePathName = strSaveDir+_T("DigitalClock.xrs");
	m_strAnalogClockFilePathName = strSaveDir+_T("AnalogClock.xrs");
	m_strTimerFilePathName = strSaveDir+_T("Timer.xrs");
	m_strLxdFilePathName = strSaveDir+_T("test.lxd");
	m_strXmlFilePathName = strSaveDir+_T("test.xml");
	m_strTxtFilePathName = strSaveDir+_T("TestTxt.txt");
	m_strTxtXrsFilePathName = strSaveDir+_T("TestTxt.xrs");
	m_strStringXrsFilePathName = strSaveDir+_T("TestString.xrs");
	m_strRtfFilePathName =strSaveDir+_T("TestRtf.rtf");
	m_strRtfXrsFilePathName =  strSaveDir+_T("TestRtf.xrs");
	UpdateData(FALSE);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTestEncodeMaterialDllDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTestEncodeMaterialDllDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTestEncodeMaterialDllDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CTestEncodeMaterialDllDlg::OnButton1() //ComplierTemperatureHumidity
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	char cTemperatureHumidityFilePathName[500]={0};
	strcpy(cTemperatureHumidityFilePathName,m_strTemperatureHumidityFilePathName);
	int iResult=ComplierTemperatureHumidity(cTemperatureHumidityFilePathName,"",16,0x000000ff,0x0000ff00,"¶","ʪ");
	if(iResult==0)
	{
		AfxMessageBox("Complier Temperature Humidity success",MB_ICONINFORMATION|MB_OK);
	}
}

void CTestEncodeMaterialDllDlg::OnButton2() 
{
	UpdateData(TRUE);
	// TODO: Add your control notification handler code here
	char cDigitalClockFilePathName[500]={0};
	strcpy(cDigitalClockFilePathName,m_strDigitalClockFilePathName);
	int iResult=ComplierDigitalClock(cDigitalClockFilePathName,"",16,0x000000ff,0x0000ff00,"");
	if(iResult==0)
	{
		AfxMessageBox("Complier Digital Clock success",MB_ICONINFORMATION|MB_OK);
	}
}
#define MACRO_DEFAULT_ANALOG_H_POINT_SIZE 2
#define MACRO_DEFAULT_ANALOG_M_POINT_SIZE 1
#define MACRO_DEFAULT_ANALOG_SZ_COLOR RGB(255,0,0)
#define MACRO_DEFAULT_ANALOG_MZ_COLOR RGB(255,255,0)
#define MACRO_DEFAULT_ANALOG_HZ_COLOR RGB(255,0,255)
#define MACRO_DEFAULT_ANALOG_M_ICO_COLOR RGB(0,255,0)
#define MACRO_DEFAULT_ANALOG_H_ICO_COLOR RGB(255,255,0)
#define MACRO_DEFAULT_ANALOG_ADDRESS_TXT_COLOR RGB(255,0,0)
#define MACRO_DEFAULT_ANALOG_DATE_TXT_COLOR	RGB(0,255,0)
#define MACRO_DEFAULT_ANALOG_WEEK_TXT_COLOR	RGB(0,255,0)
void CTestEncodeMaterialDllDlg::OnButton3() 
{
	UpdateData(TRUE);
	// TODO: Add your control notification handler code here
	char cAnalogClockFilePathName[500]={0};
	strcpy(cAnalogClockFilePathName,m_strAnalogClockFilePathName);
	int iResult=ComplierAnalogClock(cAnalogClockFilePathName,//زļ·
		0x00000000,//ɫ
		0,//״,0Բ,1
		0,//ʱ״,//0Բ,1
		4,//ʱС,
		MACRO_DEFAULT_ANALOG_H_ICO_COLOR,//ʱɫ
		0,//ֱ״,//0Բ,1
		2,//MACRO_DEFAULT_ANALOG_M_POINT_SIZE,
		MACRO_DEFAULT_ANALOG_MZ_COLOR,	//ֱɫ	
		MACRO_DEFAULT_ANALOG_HZ_COLOR,//ʱɫ
		MACRO_DEFAULT_ANALOG_MZ_COLOR,//ɫ
		MACRO_DEFAULT_ANALOG_SZ_COLOR,//ɫ
		"",//ʱ
		"",//ʱ,籱
		32,//ʱС
		0x000000ff,//ʱɫ
		"",//
		32,//С
		0x00ff0000,//ɫ
		"",//
		16,//С
		0x0000ff00,//ɫ
		320,160);
	
	if(iResult==0)
	{
		AfxMessageBox("Complier Analog Clock success",MB_ICONINFORMATION|MB_OK);
	}
	
}

void CTestEncodeMaterialDllDlg::OnButton4() 
{
	// TODO: Add your control notification handler code here
	//AfxMessageBox("Being developed");
	//return;
	UpdateData(TRUE);
	char cLxdFilePathName[500]={0};
	strcpy(cLxdFilePathName,m_strLxdFilePathName);
	char cXmlFilePathName[500]={0};
	strcpy(cXmlFilePathName,m_strXmlFilePathName);
	int iResult=LxdToXml(cLxdFilePathName,cXmlFilePathName);
	if(iResult==0)
	{
		AfxMessageBox("LxdToXml success",MB_ICONINFORMATION|MB_OK);
	}
}

void CTestEncodeMaterialDllDlg::OnButton5() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	char cFilePathName[500]={0};
	strcpy(cFilePathName,m_strTimerFilePathName);
	int iResult=ComplierTimer(cFilePathName,"",16,0x000000ff,0x0000ff00,"Away from the Christmas");
	if(iResult==0)
	{
		AfxMessageBox("Complier Timer success",MB_ICONINFORMATION|MB_OK);
	}
		
}

void CTestEncodeMaterialDllDlg::OnButtonTxtToXrs() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	char cTxtFilePathName[500]={0};
	strcpy(cTxtFilePathName,m_strTxtFilePathName);
	char cTxtXrsFilePathName[500]={0};
	strcpy(cTxtXrsFilePathName,m_strTxtXrsFilePathName);

	CString strSaveDir=GetAppPath();
	CString m_strBkPicName = strSaveDir+_T("bk.jpg");
	char  cBkPicName[500]={0};
	strcpy(cBkPicName,m_strBkPicName);
	int iResult=ComplierTxtFile(cTxtFilePathName,cTxtXrsFilePathName,32,32,NULL,0X00000000,"",0x00ff0000,8,false,false,false,1,true,1);
	if(iResult==0)
	{
		AfxMessageBox("ComplierTxtFile success",MB_ICONINFORMATION|MB_OK);
	}
	
}

void CTestEncodeMaterialDllDlg::OnButtonRtfToXrs() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	char cRtfFilePathName[500]={0};
	strcpy(cRtfFilePathName,m_strRtfFilePathName);
	char cRtfXrsFilePathName[500]={0};
	strcpy(cRtfXrsFilePathName,m_strRtfXrsFilePathName);
	CString strSaveDir=GetAppPath();
	CString m_strBkPicName = strSaveDir+_T("bk.jpg");
	char  cBkPicName[500]={0};
	strcpy(cBkPicName,m_strBkPicName);
	int iResult=ComplierRtfFile(cRtfFilePathName,cRtfXrsFilePathName,320,64,cBkPicName,0X00000000,0,true,0);
	if(iResult==0)
	{
		AfxMessageBox("ComplierRtfFile success",MB_ICONINFORMATION|MB_OK);
	}
	
}

void CTestEncodeMaterialDllDlg::OnButton6() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	char cContent[500];
	memset(cContent,0x00,500);
	strcpy(cContent,m_strStringContent);
	char cTxtXrsFilePathName[500]={0};
	strcpy(cTxtXrsFilePathName,m_strStringXrsFilePathName);

	CString strSaveDir=GetAppPath();
	CString m_strBkPicName = strSaveDir+_T("bk.jpg");
	char  cBkPicName[500]={0};
	strcpy(cBkPicName,m_strBkPicName);
	int iResult=ComplierStringContent(cContent,cTxtXrsFilePathName,320,240,NULL,0X00000000,"",0x00ff0000,16,false,false,false,0,true,0);
	if(iResult==0)
	{
		AfxMessageBox("ComplierTxtFile success",MB_ICONINFORMATION|MB_OK);
	}
	
}
